/*******************************************/
/* Tested and approved *********************/
/* int sin(x),cos(x) functions */
/*******************************************/

/*
Sinus and cosinus
Input  = -PI...PI -> -32768...32767
Output = -1...1 -> -32678...32767
max error = 3e-4, avg. error = 1e-4
Uses mul() function
*/

#include "mul.h"


int i_sin(int x)
{

static int const i_sintable[33] =
 {
 0,1608,3212,4808,6393,7962,9512,11039,
 12540,14010,15447,16846,18205,19520,20788,22006,
 23170,24279,25330,26320,27246,28106,28899,29622,
 30274,30853,31357,31786,32138,32413,32610,32729,
 32767
 };


unsigned char i,qtr=0;
int result;

if(x<0)
 {
 x=-x;
 qtr++;
 }

if(((unsigned int)x)>=16384) x=32768u-x;


i=(unsigned char)(x>>9);
x=(x&0x1ff)<<3;


result=i_sintable[i]+(int)(mul((i_sintable[i+1]-i_sintable[i])<<4,x)>>16);

if(qtr) result = -result;

return result;
}

int i_cos(int x)
{
return i_sin(x+16384);
}
